package de.fhdw.gaming.ipspiel23.ht.domain;

import de.fhdw.gaming.core.domain.GameBuilder;
import de.fhdw.gaming.core.domain.GameException;
import de.fhdw.gaming.ipspiel23.ht.strategy.IHTStrategy;

/**
 * A builder for {@link HTGame}s.
 */
public interface IHTGameBuilder extends GameBuilder {
    
    /**
     * Creates an {@link IHTPlayerBuilder} which allows to create and add a player to the game together with their
     * strategy.
     */
    IHTPlayerBuilder createPlayerBuilder();

    /**
     * Adds a player and their corresponding strategy.
     *
     * @param player   The player.
     * @param strategy The player's strategy.
     * @throws GameException if adding the player is not allowed by the rules of the game.
     */
    IHTGameBuilder addPlayer(IHTPlayer player, IHTStrategy strategy) throws GameException;

    @Override
    IHTGame build(int id) throws GameException, InterruptedException;
}