package de.fhdw.gaming.ipspiel23.ht.domain;

import de.fhdw.gaming.core.domain.GameBuilderFactory;
import de.fhdw.gaming.core.domain.GameException;
import de.fhdw.gaming.core.ui.InputProvider;

/**
 * A factory for {@link IHTGameBuilder}s.
 */
public interface IHTGameBuilderFactory extends GameBuilderFactory {
    
    /**
     * The name of the parameter which specifies the outcome of the player if the both players answer the 
     * same thing (Heads/Heads or Tails/Tails).
     */
    String PARAM_PLAYER_OUTCOME_EQUAL = "playerOutcomeOnEqualSides";

    /**
     * The name of the parameter which specifies the outcome of the player if the both players answer different
     * things (Heads/Tails or Tails/Heads).
     */
    String PARAM_PLAYER_OUTCOME_DIFFERENT = "playerOutcomeOnDifferentSides";

    @Override
    IHTGameBuilder createGameBuilder(InputProvider inputProvider) throws GameException;
}