package de.fhdw.gaming.ipspiel23.ht.strategy.impl.edge;

import java.util.Optional;

import de.fhdw.gaming.core.domain.GameException;
import de.fhdw.gaming.ipspiel23.ht.domain.IHTPlayer;
import de.fhdw.gaming.ipspiel23.ht.domain.IHTState;
import de.fhdw.gaming.ipspiel23.ht.moves.IHTMove;
import de.fhdw.gaming.ipspiel23.ht.moves.factory.IHTMoveFactory;
import de.fhdw.gaming.ipspiel23.ht.strategy.impl.HTStrategy;
import de.fhdw.gaming.ipspiel23.ht.strategy.impl.heads.HTHeadsStrategy;

/**
 * Implements {@link HTStrategy} by always playing "edge".
 */
public class HTEdgeStrategy extends HTStrategy {
    
    /**
     * Creates an {@link HTHeadsStrategy}.
     * @param moveFactory The factory for creating HT moves.
     */
    protected HTEdgeStrategy(final IHTMoveFactory moveFactory) {
        super(moveFactory);
    }

    @Override
    public Optional<IHTMove> computeNextMove(final int gameId, final IHTPlayer player, final IHTState state)
            throws GameException, InterruptedException {
        return Optional.of(getMoveFactory().createEdgeMove());
    }
}
